import * as t from '@babel/types';
export declare type NodeType<type extends string> = type extends keyof t.Aliases ? t.Aliases[type] : Extract<t.Node, {
    type: type;
}>;
export declare type SimpleFunction<TKey extends string, TState> = (node: NodeType<TKey>, state: TState) => void;
export declare function simple<TState>(node: t.Node, visitors: {
    [key in keyof t.Aliases | t.Node['type']]?: SimpleFunction<key, TState> | {
        enter?: SimpleFunction<key, TState>;
        exit?: SimpleFunction<key, TState>;
    };
}, state: TState): void;
export declare type AncestorFunction<TKey extends string, TState> = (node: NodeType<TKey>, state: TState, ancestors: t.Node[]) => void;
export declare function ancestor<TState>(node: t.Node, visitors: {
    [key in keyof t.Aliases | t.Node['type']]?: AncestorFunction<key, TState> | {
        enter?: AncestorFunction<key, TState>;
        exit?: AncestorFunction<key, TState>;
    };
}, state: TState): void;
export declare function recursive<TState>(node: t.Node, visitors: {
    [key in keyof t.Aliases | t.Node['type']]?: (node: NodeType<key>, state: TState, recurse: (node: t.Node) => void) => void;
}, state: TState): void;
